/*
 Basic Navigation Program
 Frankensteined from many sources
 Works okay so far
*/

#include "abdrive.h"
#include "ping.h"
#include "servodiffdrive.h"
#include "simpletools.h"

// Declare functions
int ctr_ping(void);
int eval_dist(void);
int scan_ahead(void);
int turn_Bob(void);

//Declare global variables
int array_pos;
int counter1;
int direction;
int distance;
int ping_dist[5];
int delay = 500;									// Set "delay" to 0.5 second
int det_rng = 20;									// Set "det_rng" to 35cm

int main()											// Here we go!
{
	ctr_ping();
	//drive_ramp(4, 4);
	drive_speed(64, 64);							// Turn servos @ 64 TPS

	while(ping_cm(17) >= det_rng) pause(5);			// Wait until object in range on pin 17
    drive_speed(0, 0);								// Stop servos
    scan_ahead();
    eval_dist();
    ctr_ping();
	//drive_goto(57, -53);							// Two wheel pivot ~180 degrees
	drive_speed(0, 0);								// Stop servos
	drive_speed(64, 64);							// Turn servos @ 64 TPS
	while(ping_cm(17) >= det_rng) pause(5);			// Wait until object in range on pin 17
    drive_speed(0, 0);								// Stop servos
	// Placeholder for more nerdy stuff!	:)
	freqout(4, 1000, 3000);							// Piezo Alert (Pin 4, 1 Sec,. 3KHz) 

	return 0;										// Okay, we've had enough
}

int ctr_ping()// Center Ping sensor
{
    freqout(4, 1000, 500 );							// Beep (Pin 4, 1 Sec., 0.5KHz)

    for ( int x = 0; x < 7; x++ )					// Loop 7 times to allow Ping servo to align
	{
        servo_set(16, 1450);						// Rotate Ping forward (980 ~90 degrees, 1450 ~90 degrees)
        pause(delay);
	}

    servo_stop();

	return(0);										// Back to main 
}

int scan_ahead()// Five sector scan
{
	servo_set(16, 625);								// Turn servo 90 degrees right
	distance = ping_cm(17);							// Retrieve data from Ping on pin 17
	ping_dist[0] = distance;						// Assign full right distance to array element 0
	pause(delay);

	servo_set(16, 1050);							// Turn servo 45 degrees right
	distance = ping_cm(17);							// Retrieve data from Ping on pin 17
	ping_dist[1] = distance;						// Assign half right distance to array element 1
	pause(delay);

	servo_set(16, 1450);							// Turn servo full forward
	distance = ping_cm(17);							// Retrieve data from Ping on pin 17
	ping_dist[2] = distance;						// Assign full ahead distance to array element 2
	pause(delay);

	servo_set(16, 1900);							// Ture servo 45 degrees left
	distance = ping_cm(17);							// Retrieve data from Ping on pin 17
	ping_dist[3] = distance;						// Assign half left distance to array element 3
	pause(delay);

	servo_set(16, 2250);							// Ture servo 90 degrees left
	distance = ping_cm(17);							// Retrieve data from Ping on pin 17
	ping_dist[4] = distance;						// Assign full left distance to array element 4
	pause(delay);

	return 0;
}

int eval_dist()										// Determine longest distance from Ping
{
	int max_val;
	int array_size = 5;
	int counter;
  
	array_pos = 0;
	max_val = ping_dist[0];							// Initialize max_val to array position zero    

	for(counter = 0; counter < array_size; counter++)
	{
		if (ping_dist[counter] > max_val)
		{
			max_val  = ping_dist[counter];
			array_pos = counter;
		}
	}

	turn_Bob();

	return 0;
}

int turn_Bob()										// Function to change Bob's direction of travel
{
	switch(array_pos)
	{
		case 0:										// Note the colon, not a semicolon
			freqout(4, 1000, 3000);
			drive_goto(-28, 27);
			drive_speed(0, 0);						// Stop servos

			break;

		case 1:
			freqout(4, 1000, 3000);
			pause(delay);
			freqout(4, 1000, 3000);
			drive_goto(14, -14);
			drive_speed(0, 0);						// Stop servos

			break;
    
		case 2:
			freqout(4, 1000, 3000);
			pause(delay);
			freqout(4, 1000, 3000);
			pause(delay);
			freqout(4, 1000, 3000);
			//drive_goto(64, 64);
			drive_speed(0, 0);						// Stop servos

			break;
    
		case 3:
			freqout(4, 1000, 3000);
			pause(delay);
			freqout(4, 1000, 3000);
			pause(delay);
			freqout(4, 1000, 3000);
			pause(delay);
			freqout(4, 1000, 3000);
			drive_goto(14, -14);
			drive_speed(0, 0);						// Stop servos

			break;    

		case 4:
			freqout(4, 1000, 3000);
			pause(delay);
			freqout(4, 1000, 3000);
			pause(delay);
			freqout(4, 1000, 3000);
			pause(delay);    
			freqout(4, 1000, 3000);
			pause(delay);
			freqout(4, 1000, 3000);    
			pause(delay);
			drive_goto(28, -27);
			drive_speed(0, 0);						// Stop servos
			
			break;

		default:
			freqout(4, 1000, 3000);
			pause(delay);
			freqout(4, 1000, 3000);
			pause(delay);
			freqout(4, 1000, 3000);
			pause(delay);    
			freqout(4, 1000, 3000);
			pause(delay);
			freqout(4, 1000, 3000);
			pause(delay);
			freqout(4, 1000, 3000);    
			pause(delay);
			drive_goto(53, -57);
			drive_speed(0, 0);						// Stop servos

			break;
	}

	return 0;    
}